// ExifTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ExifTest.h"
#include "ExifTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExifTestDlg dialog

CExifTestDlg::CExifTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExifTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExifTestDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExifTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExifTestDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExifTestDlg, CDialog)
	//{{AFX_MSG_MAP(CExifTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnLoadEXIF)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExifTestDlg message handlers

BOOL CExifTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CExifTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CExifTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CExifTestDlg::OnLoadEXIF() 
{
	CString filename;
	if (!PromptForFileName(filename, AFX_IDS_OPENFILE,
	  OFN_HIDEREADONLY | OFN_FILEMUSTEXIST, TRUE, NULL))
		return; // open cancelled

	FILE* hFile=fopen(filename,"rb");

	if (hFile){

		memset(&m_exifinfo,0,sizeof(EXIFINFO));

		Cexif exif(&m_exifinfo);
		exif.DecodeExif(hFile);

		fclose(hFile);

		if (m_exifinfo.IsExif) ShowInfo();
		else MessageBox("No EXIF information found!","EXIF",MB_OK);

	}
}

void CExifTestDlg::ShowInfo()
{
	CString s,t;
	s="";

    if (m_exifinfo.CameraMake[0]){
        t.Format("Camera make  : %s\n",m_exifinfo.CameraMake); s+=t;
        t.Format("Camera model : %s\n",m_exifinfo.CameraModel); s+=t;
    }
    if (m_exifinfo.DateTime[0]){
        t.Format("Date/Time    : %s\n",m_exifinfo.DateTime); s+=t;
    }
    if (m_exifinfo.Version[0]){
        t.Format("Exif version : %s\n",m_exifinfo.Version); s+=t;
    }

    t.Format("Width x Height   : %d x %d\n",m_exifinfo.Width, m_exifinfo.Height); s+=t;

	if ((m_exifinfo.ResolutionUnit!=0)&&(m_exifinfo.Xresolution!=0)){
		t.Format("X resolution (dpi) : %5.1f\n",m_exifinfo.Xresolution/m_exifinfo.ResolutionUnit); s+=t;
	}
	if ((m_exifinfo.ResolutionUnit!=0)&&(m_exifinfo.Yresolution!=0)){
		t.Format("Y resolution (dpi) : %5.1f\n",m_exifinfo.Yresolution/m_exifinfo.ResolutionUnit); s+=t;
	}

    if (m_exifinfo.Orientation > 1){
        t.Format("Orientation  : %s\n", m_exifinfo.Orientation); s+=t;
    }
    if (m_exifinfo.IsColor == 0){
        t.Format("Color/bw     : Black and white\n"); s+=t;
    }
    if (m_exifinfo.FlashUsed >= 0){
        t.Format("Flash used   : %s\n",m_exifinfo.FlashUsed ? "Yes" :"No"); s+=t;
    }
    if (m_exifinfo.FocalLength){
        t.Format("Focal length : %4.1fmm",(double)m_exifinfo.FocalLength); s+=t;
        if (m_exifinfo.CCDWidth){
            t.Format("  (35mm equivalent: %dmm)",
                        (int)(m_exifinfo.FocalLength/m_exifinfo.CCDWidth*36 + 0.5)); s+=t;
        }
        t.Format("\n"); s+=t;
    }

    if (m_exifinfo.CCDWidth){
        t.Format("CCD width    : %4.2fmm\n",(double)m_exifinfo.CCDWidth); s+=t;
    }

    if (m_exifinfo.ExposureTime){
        t.Format("Exposure time:%6.3f s ",(double)m_exifinfo.ExposureTime); s+=t;
        if (m_exifinfo.ExposureTime <= 0.5){
            t.Format(" (1/%d)",(int)(0.5 + 1/m_exifinfo.ExposureTime)); s+=t;
        }
        t.Format("\n"); s+=t;
    }
	if (m_exifinfo.Brightness){
		t.Format("Brightness : %6.3f\n",m_exifinfo.Brightness); s+=t;
	}
    if (m_exifinfo.ApertureFNumber){
        t.Format("Aperture     : f/%3.1f\n",(double)m_exifinfo.ApertureFNumber); s+=t;
    }
    if (m_exifinfo.Distance){
        if (m_exifinfo.Distance < 0){
            t.Format("Focus dist.  : Infinite\n"); s+=t;
        }else{
            t.Format("Focus dist.  : %4.2fm\n",(double)m_exifinfo.Distance); s+=t;
        }
    }


    if (m_exifinfo.ISOequivalent){ // 05-jan-2001 vcs
        t.Format("ISO equiv.   : %2d\n",(int)m_exifinfo.ISOequivalent); s+=t;
    }
    if (m_exifinfo.ExposureBias){ // 05-jan-2001 vcs
        t.Format("Exposure bias:%4.2f\n",(double)m_exifinfo.ExposureBias); s+=t;
    }
        
    if (m_exifinfo.Whitebalance){ // 05-jan-2001 vcs
        switch(m_exifinfo.Whitebalance) {
        case 1:
            t.Format("Whitebalance : sunny\n"); s+=t;
            break;
        case 2:
            t.Format("Whitebalance : fluorescent\n"); s+=t;
            break;
        case 3:
            t.Format("Whitebalance : incandescent\n"); s+=t;
            break;
        default:
            t.Format("Whitebalance : cloudy\n"); s+=t;
        }
    }
    if (m_exifinfo.MeteringMode){ // 05-jan-2001 vcs
        switch(m_exifinfo.MeteringMode) {
        case 2:
            t.Format("Metering Mode: center weight\n"); s+=t;
            break;
        case 3:
            t.Format("Metering Mode: spot\n"); s+=t;
            break;
        case 5:
            t.Format("Metering Mode: matrix\n"); s+=t;
            break;
        }
    }
    if (m_exifinfo.ExposureProgram){ // 05-jan-2001 vcs
        switch(m_exifinfo.ExposureProgram) {
        case 2:
            t.Format("Exposure     : program (auto)\n"); s+=t;
            break;
        case 3:
            t.Format("Exposure     : aperture priority (semi-auto)\n"); s+=t;
            break;
        case 4:
            t.Format("Exposure     : shutter priority (semi-auto)\n"); s+=t;
            break;
        }
    }
    if (m_exifinfo.CompressionLevel){ // 05-jan-2001 vcs
        switch(m_exifinfo.CompressionLevel) {
        case 1:
            t.Format("Jpeg Quality : basic\n"); s+=t;
            break;
        case 2:
            t.Format("Jpeg Quality : normal\n"); s+=t;
            break;
        case 4:
            t.Format("Jpeg Quality : fine\n"); s+=t;
            break;
       }
    }

    t.Format("Encoding      : "); s+=t;
	switch(m_exifinfo.Process){
	case 0xC0: //M_SOF0
		t.Format("Baseline\n"); s+=t;
		break;
	case 0xC1: //M_SOF1
		t.Format("Extended sequential\n"); s+=t;
		break;
	case 0xC2: //M_SOF2
		t.Format("Progressive\n"); s+=t;
		break;
	case 0xC3: //M_SOF3
		t.Format("Lossless\n"); s+=t;
		break;
	case 0xC5: //M_SOF5
		t.Format("Differential sequential\n"); s+=t;
		break;
	case 0xC6: //M_SOF6
		t.Format("Differential progressive\n"); s+=t;
		break;
	case 0xC7: //M_SOF7
		t.Format("Differential lossless\n"); s+=t;
		break;
	case 0xC9: //M_SOF9
		t.Format("Extended sequential, arithmetic coding\n"); s+=t;
		break;
	case 0xCA: //M_SOF10
		t.Format("Progressive, arithmetic coding\n"); s+=t;
		break;
	case 0xCB: //M_SOF11
		t.Format("Lossless, arithmetic coding\n"); s+=t;
		break;
	case 0xCD: //M_SOF13
		t.Format("Differential sequential, arithmetic coding\n"); s+=t;
		break;
	case 0xCE: //M_SOF14
		t.Format("Differential progressive, arithmetic coding\n"); s+=t;
		break;
	case 0xCF: //M_SOF0
		t.Format("Differential lossless, arithmetic coding\n"); s+=t;
		break;
	default:
		t.Format("Unknown\n"); s+=t;
		break;
	}

    // Print the comment. Print 'Comment:' for each new line of comment.
    if (m_exifinfo.Comments[0]){
        int a,c;
        t.Format("Comment      : "); s+=t;
        for (a=0;a<MAX_COMMENT;a++){
            c = m_exifinfo.Comments[a];
            if (c == '\0') break;
            if (c == '\n'){
                // Do not start a new line if the string ends with a carriage return.
                if (m_exifinfo.Comments[a+1] != '\0'){
                    t.Format("\nComment      : "); s+=t;
                }else{
                    t.Format("\n"); s+=t;
                }
            }else{
                s+=c;
            }
        }
    }

    t.Format("\n"); s+=t;
		
	MessageBox(s,"EXIF",MB_OK|MB_ICONQUESTION);

}

BOOL CExifTestDlg::PromptForFileName(CString& fileName, UINT nIDSTitle, 
	DWORD dwFlags, BOOL bOpenFileDialog, int* pType)
{
	CFileDialog dlgFile(bOpenFileDialog);
	CString title;
	if (bOpenFileDialog) title="Open file"; else title="Save file";

	dlgFile.m_ofn.Flags |= dwFlags;

	int nDocType = (pType != NULL) ? *pType : 0;

	int nIndex = 0;

	dlgFile.m_ofn.nFilterIndex = nIndex +1;
	CString strDefExt = "pal";
	dlgFile.m_ofn.lpstrDefExt = strDefExt;
		
	CString strFilter = "*.jpg";
	strFilter += (TCHAR)NULL;
	strFilter += "*.jpg";
	strFilter += (TCHAR)NULL;
	strFilter += "*.*";
	strFilter += (TCHAR)NULL;
	strFilter += "*.*";
	strFilter += (TCHAR)NULL;

	dlgFile.m_ofn.lpstrFilter = strFilter;
	dlgFile.m_ofn.lpstrTitle = title;
	dlgFile.m_ofn.lpstrFile = fileName.GetBuffer(_MAX_PATH);

	BOOL bRet = (dlgFile.DoModal() == IDOK) ? TRUE : FALSE;
	fileName.ReleaseBuffer();
	if (bRet){
		if (pType != NULL){
			int nIndex = (int)dlgFile.m_ofn.nFilterIndex - 1;
			ASSERT(nIndex >= 0);
		}
	}
	return bRet;
}
